unit UFRegionales;

interface
uses
  SysUtils, Variants, Classes, math, UApoyo;


  procedure FR_BordeX    ( Ma : Mat3d; var Mb : Mat3d);
  procedure FR_BordeY    ( Ma : Mat3d; var Mb : Mat3d);
  procedure FR_BordeXY   ( Ma : Mat3d; var Mb : Mat3d);

  procedure FR_BordeConX ( Ma : Mat3d; var Mb : Mat3d;
                           MC : MatC3x3);

  function  Conv3        ( Ma : Mat3d; MC : MatC3x3;
                          x,y,can : integer): single;
                          

  procedure FR_MediaConX ( Ma : Mat3d; var Mb : Mat3d;
                           MC : MatCnxm);

implementation

// Borde X Simple
  procedure FR_BordeX( Ma : Mat3d; var Mb : Mat3d);
  var
    x,y,can : integer;
  begin
    Mat2Mat(Ma,Mb);

    for can := 0 to 2 do if Kanales[can]
      then // aplica el filtro
        for y := _y1 to _y2 - 1 do
          for x := _x1 to _x2 - 2 do
          // ---
            Mb.dat[x][y][can] := Ma.dat[x+1][y][can] -
                                 Ma.dat[x  ][y][can];
          // ---
  end;

// Borde Y Simple
  procedure FR_BordeY( Ma : Mat3d; var Mb : Mat3d);
  var
    x,y,can : integer;
  begin
    Mat2Mat(Ma,Mb);

    for can := 0 to 2 do if Kanales[can]
      then // aplica el filtro
        for y := _y1 to _y2 - 2 do
          for x := _x1 to _x2 - 1 do
          // ---
            Mb.dat[x][y][can] := Ma.dat[x][y+1][can] -
                                 Ma.dat[x][y  ][can];
          // ---
  end;

// Borde X-Y Simple
  procedure FR_BordeXY  ( Ma : Mat3d; var Mb : Mat3d);
  var
    x,y,can : integer;
    dx,dy   : single;
  begin
    Mat2Mat(Ma,Mb);

    for can := 0 to 2 do if Kanales[can]
      then // aplica el filtro
        for y := _y1 to _y2 - 2 do
          for x := _x1 to _x2 - 2 do begin
          // ---
            dx := Ma.dat[x+1][y][can] -
                  Ma.dat[x  ][y][can];
            dy := Ma.dat[x][y+1][can] -
                  Ma.dat[x][y  ][can];
            Mb.dat[x][y][can] := MAX(abs(dx),abs(dy));
          // ---

          end;
  end;

  // Convolucin 3x3
  function  Conv3       ( Ma : Mat3d; MC : MatC3x3;
                          x,y,can : integer):single;
  var
    i,j : integer;
    sum : single;
  begin
    sum := 0;
    for j := -1 to 1 do
      for i := -1 to 1 do
        sum := sum + Ma.dat[x+i][y+j][can]*MC[i][j];

    result := sum;    
  end;

  // Convolucin com MC de 3x3
  procedure FR_BordeConX ( Ma : Mat3d; var Mb : Mat3d;
                           MC : MatC3x3);
var
    x,y,can : integer;
  begin
    Mat2Mat(Ma,Mb);

    for can := 0 to 2 do if Kanales[can]
      then // aplica el filtro
        for y := _y1+1 to _y2 - 2 do
          for x := _x1+1 to _x2 - 2 do
          // ---
            Mb.dat[x][y][can]:= Conv3(Ma,MC, x,y,can)
          // ---
  end;


  // Convolucin con MC de nxm
  procedure FR_MediaConX ( Ma : Mat3d; var Mb : Mat3d;
                           MC : MatCnxm);
  var
    a,b,
    x,y,can : integer;
    ff      : single;

  //  -------  metodo interno  -----
  // Convolucin nxm  medias
  function  Conv3 ( x,y,can : integer):single;
  var
    i,j    : integer;
    sum    : single;
  begin
    sum := 0;
    for j := -b to b do
      for i := -a to a do
        sum := sum + Ma.dat[x+i][y+j][can]*MC.dat[a+i][b+j];

    result := sum;
  end;
  //  -----------------------------

  begin
    Mat2Mat(Ma,Mb);

    a  := MC.nx div 2;
    b  := MC.ny div 2;
    ff := MC.fac;

    for can := 0 to 2 do if Kanales[can]
      then // aplica el filtro
        for y := _y1+b to _y2 - b-1 do
          for x := _x1+a to _x2 - a-1 do
          // ---
            Mb.dat[x][y][can]:= Conv3(x,y,can)/ff;
          // ---
  end;

end.
